#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include "math.h"
#define M 8		// 
#define N 2             // 
#define EPS 0.001       //   

using namespace std;

//,      
//       

void my_findMax(double *Mx[],int m,int n,int m_cur,int n_cur,int* x, double* b)
{
//m_cur,n_cur -     
//x -   
//b -   
	int i_max,j_max,i,j;
	i_max=m_cur;
	j_max=n_cur;
	int num;
	double temp;
	double max=0;
	for (i=m_cur;i<m;i++)
		for(j=n_cur;j<n;j++)
			if( fabs( Mx[i][j] ) > max)
			{
				i_max=i;
				j_max=j;
				max=fabs( Mx[i][j] );
			}
	if(i_max==m_cur && j_max==n_cur)
		return;
	// 
	for(j=0;j<n;j++)
	{
		temp=Mx[i_max][j];
		Mx[i_max][j]=Mx[m_cur][j];
		Mx[m_cur][j]=temp;
	}
	//  
	temp=b[m_cur];
	b[m_cur]=b[i_max];
	b[i_max]=temp;
	// 
	for(i=0;i<m;i++)
	{
		temp=Mx[i][j_max];
		Mx[i][j_max]=Mx[i][n_cur];
		Mx[i][n_cur]=temp;
	}
	//  
	num=x[n_cur];
	x[n_cur]=x[j_max];
	x[j_max]=num;
}


//   ,   
//(     
//   )

int my_gauss(double *Mx[], int m, int n,int* x, double* b)
//b -   
//x -   
{
	int rk=0;
	double temp;
	int i,j,k,l;
	// 
	for( i=0; i<m; i++)
	{
		if(i==n)
			return rk;
		my_findMax(Mx,m,n,i,i,x,b);
		if ( fabs( Mx[i][i] ) < EPS )
			return rk;
		rk++;
		temp=Mx[i][i];
		b[i]=b[i]/temp;
		for(j=i;j<n;j++)
			Mx[i][j]=Mx[i][j]/temp;
		if(i==m-1)
			break;
		for(k=i+1;k<m;k++)
		{
			temp=Mx[k][i];
			b[k]=b[k]-b[i]*temp;
			for(l=i;l<n;l++)
				Mx[k][l]=Mx[k][l]-Mx[i][l]*temp;
		}
	}
	return rk;
}

//    
// 
int f(int * v, int m,int r,int Num,int h)
{
//m -    
//r -     
//Num -   
//h -  
	if(m==0 && v[m]<=Num-1-(r-m-1)-1)
	{
		v[m]=v[m]+1;
		for(int i=m+1;i<=r;i++)
			v[i]=v[i-1]+1;
	}
	else if(m!=0 && v[m]<=Num-1-(r-m-1)-h)
	{
		v[m]=v[m]+h;
		for(int i=m+1;i<=r;i++)
			v[i]=v[i-1]+1;
	}
	else
	{
		if(m>0)
			return f(v,m-1,r,Num,h);
		else
			return 0;
	}
	return 1;
}

//  
//    
int run(int m, int r, int h)
//m -   
//r -  
//h -  
{
	int*set,state,sum=0,i;
	set=(int*)malloc((r)*sizeof(int));
	for(i=0;i<r;i++)
		set[i]=i;
	state=1;
	while(state!=3)
	{
		switch(state)
		{
			case 1:
				sum++;
				set[r-1]=set[r-1]+h;
				if(set[r-1]>m-1)
				{
					state=2;
					break;
				}
				break;
			case 2:
				if(r-2<0)
				{
					state=3;
					break;
				}
				if(!f(set,r-2,r,m,h))
				{
					state=3;
					break;
				}
				state=1;
				break;
		}
	}
	return sum;
}

int Solve_sub(int *num, double *Mx[], int r,int *x, double*b1, double* slv)
//,     
// 1    , 0 - .
{
//num -   
//Mx -  
//r -   Mx
//slv -  
	int i,j,rk;
	double *b;
	bool feas=true;
	double temp;
	double temp1[N];
	//    ---------------------------
	double **sub;
	sub=(double**)malloc(r*sizeof(double*));
	for(i=0;i<r;i++)
		sub[i]=(double*)malloc(N*sizeof(double));
	for(i=0; i<r;i++)
		for(j=0;j<N;j++)
			sub[i][j]=Mx[num[i]][j];
	b=(double*)malloc(r*sizeof(double));
	for(i=0;i<r;i++)
		b[i]=b1[num[i]];
	//     -------------------
	//   
	rk=my_gauss(sub,r,N,x,b);
	if(rk!=r)
		return 0;
	//  .
	//  
	for(int i=rk;i<r;i++)
		feas=feas&&(fabs( b[i] ) < EPS);
	if(!feas)
		return 0;
	//  .
	//  
	for(i=rk;i<N;i++)
		slv[i]=0.0;
	slv[rk-1]=b[rk-1];
	for(int i=rk-2;i>=0;i--)
	{
		temp=0;
		for(j=i+1;j<N;j++)
			temp+=slv[j]*sub[i][j];
		slv[i]=b[i]-temp;
	}
	//  
	for(i=0;i<N;i++)
	{
		temp1[x[i]]=slv[i];
	}
	for(i=0;i<N;i++)
	{
		slv[i]=temp1[i];
	}
	return 1;
}

//     ,
// ,   
int extract(double *Mx[],double*slv,double*b,int* ans)
{
//slv -  
//b -   
//ans -   
	int i,j;
	int sum=0;
	int counter=0;
	double res;
	for(i=0;i<M;i++)
		ans[i]=-1;
	for(i=0;i<M;i++)
	{
		res=0;
		for(j=0;j<N;j++)
			res=res+slv[j]*Mx[i][j];
		if(res>b[i] || fabs(res-b[i])<EPS)
		{
			sum++;
			ans[counter]=i;
			counter++;
		}
	}
	return sum;
}

// 
void my_MF(double *Mx[], int h,double*b, int * MF)
{
//Mx -  
//h -   ()
	int i,j;
	int*set,state;
	int rk;
	int x[M];
	int sol[M];
	double **Working;
	double slv[N];
	double b1[M];
	int max=0;
	int ext_cmp;
	//   ------------
	Working=(double**)malloc(M*sizeof(double*));
	for(i=0;i<M;i++)
		Working[i]=(double*)malloc(N*sizeof(double));
	for(i=0; i<M;i++)
		for(j=0;j<N;j++)
			Working[i][j]=Mx[i][j];
	//  
	for(i=0;i<M;i++)
		x[i]=i;
	for(i=0;i<M;i++)
		b1[i]=b[i];
	//----------------------------------------------
	rk=my_gauss(Working,M,N,x,b1);
	cout<<rk<<endl;
	//  
	set=(int*)malloc((rk)*sizeof(int));
	for(i=0;i<rk;i++)
		set[i]=i;
	//------ -------------
	for(i=0;i<M;i++)
		MF[i]=-1;
	//----------------------------------------------
	cout<<"MF WORKING......."<<endl;
	state=1;
	while(state!=3)
	{
		switch(state)
		{
			case 1:
				// 
				if(Solve_sub(set,Mx,rk,x,b,slv))
				{
					ext_cmp=extract(Mx,slv,b,sol);
					if(max<ext_cmp)
					{
						for(i=0;i<M;i++)
							MF[i]=sol[i]+1;
						max=ext_cmp;
					}
				}
				set[rk-1]=set[rk-1]+h;
				if(set[rk-1]>M-1)
				{
					state=2;
					break;
				}
				break;
			case 2:
				if(rk-2<0)
				{
					state=3;
					break;
				}
				if(!f(set,rk-2,rk,M,h))
				{
					state=3;
					break;
				}
				state=1;
				break;
		}
	}
	for (i=0;i<M;i++)
		cout<<MF[i]<<endl;
}

int main()
{
	int *set,state=1;
	bool flag=true;
	int r;
	int i,j;
	double **m;
	double **work;
	double b[M];
	int num[2];
	cout<<run(M,2,1);
	//   ----------------------------
	m=(double**)malloc(M*sizeof(double*));
	for(i=0;i<M;i++)
		m[i]=(double*)malloc(N*sizeof(double));
	
	work=(double**)malloc(M*sizeof(double*));
	for(i=0;i<M;i++)
		work[i]=(double*)malloc(N*sizeof(double));

	// 

	for(i=0;i<M;i++)
		for(j=0;j<N;j++)
		{
			cout<<"Enter ("<<i<<","<<j<<") element: ";
			cin>>m[i][j];
		}
	for(int i=0;i<M;i++)
		{
			cout<<"Enter ("<<i<<") element: ";
			cin>>b[i];
		}
		cout<<endl;
	//-----------------------------------------------------------------
		int MF[M];
	my_MF(m,2,b,MF);
}


	

